/*	
 *	nodo3.c
 *
 *	tZxς ` ΍vO
 *
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Tue Jul 26 20:58:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include "c33208.h"

void usleep(unsigned long usec);
void lcd_init();

/****************************************************************************
 *
 ****************************************************************************/

#define plc_IO ((volatile struct c_IOtag*)0x40000) /* c33208.hp */

unsigned char vbuff[DISP_X * DISP_Y]; /* z */

const int DITHER[8][8] = {
         0,32, 8,40, 2,34,10,42,
        48,16,56,24,50,18,58,26,
        12,44, 4,36,14,46, 6,38,
        60,28,52,20,62,30,54,22,
         3,35,11,43, 1,33, 9,41,
        51,19,59,27,49,17,57,25,
        15,47, 7,39,13,45, 5,37,
        63,31,55,23,61,29,53,21,
};

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	int x, y, c;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	/* zʂ̏B */
#if 0
	for(y = 0; y < DISP_Y; y++) {
		for(x = 0; x < DISP_X; x++) {
			c = x * 2;
			c = (c + DITHER[y & 7][x & 7] + (85 - 63) / 2) / 85;
			vbuff[DISP_X * y + x] = c;
		}
	}
#else
	x = y = c = 0; /* x} */
	memset(vbuff, 3, sizeof vbuff);
#endif
	pceFontSetType(0x82);
	pceFontSetTxColor(3);
	pceFontSetBkColor(0);
	pceFontSetPos(0, 0);
	pceFontPutStr("A:pceLCDSetOrientation\n");
	pceFontPutStr("B:LCDC init (manually)\n");
	pceFontPutStr("SELECT:EXIT\n");

	/* ŏ̉ʓ]B */
	pceLCDTrans();
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int pad;

	/* {^ꂽ... */
	pad = pcePadGet();
	if(pad & TRG_A) {
		pceLCDSetOrientation(0);
		pceLCDTrans(); /* zʍē] */
	}
	if(pad & TRG_B) {
		lcd_init();
		pceLCDTrans(); /* zʍē] */
		pceLCDDispStart(); /* ʕ\ON */
	}
	if(pad & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
}

/****************************************************************************
 *	usleep
 ****************************************************************************/

/* }CNbPʂ̎ԑ҂s܂B
 * [in]
 *	usec		҂[}CNb]
 * [note]
 *	* xJEgipceTimerAdjustPrecisionCount()j̒ĺA
 *	  16bit^C}̃JE^f[^ClockTicksl琶Ă܂B
 *	* ǂ̒l荞݋֎~JEgAbvp̂ŁA
 *	  荞݋֎~łusleep()gĎԑ҂sƂł܂B
 */
void
usleep(unsigned long usec)
{
	unsigned long st, ed;

	st = pceTimerGetPrecisionCount();
	do {
		ed = pceTimerGetPrecisionCount();
	} while(pceTimerAdjustPrecisionCount(st, ed) < usec);
}

/****************************************************************************
 *	lcd_init
 ****************************************************************************/

/* LCDCď܂B
 */
void
lcd_init()
{
	volatile unsigned char* bp = (volatile unsigned char*)plc_IO;
	unsigned char buf[100/*O{炢]TĂ܂*/], *p, cmd;
	int len, i;

	/* 炩ߏR}h쐬Ă܂B
	 * * S6B0741f[^V[g(DS_S6B0741_V21.pdf)56y[W
	 *   uReferential Instruction Set-up Flow:
	 *     Initializing with the built-in Power Supply Circuitsv
	 *   QƂĂB
	 * * eݒĺA݂P/ECEJ[l(1.18)ɍ킹Ă܂B
	 * * oi(?)LCDuOGM-128GB21T-S-KD010v̐ݒlƂ͈قȂ܂B
	 *   OGM-128GB21T-S-KD010f[^V[g(128GB21T-S-KD010.pdf)QƂĂB
	 * * 128GB21T-S-KD010.pdf4y[Wu1. FEATURESvɏĂ鐄ݒlł́F
	 *	Driving method ... 1/128 duty, 1/12 bias
	 *   ƂȂĂAP/ECEJ[lł̐ݒlF
	 *	Driving method ... 1/128 duty, 1/11 bias
	 *    Ƃ͏قȂ܂B
	 *   iP/ECEJ[l̂1/12`ՂARg1/12̂܂܂łj
	 * * A10y[Wu9. PROGRAM SETTING VALUEvɏĂ鐄ݒlł́F
	 *	BLACK     : 9990
	 *	DARK GRAY : 9900
	 *	LIGHT GRAY: 9000
	 *	WHITE     : 0000
	 *   ƂȂĂAP/ECEJ[lł̐ݒlF
	 *	BLACK     : 8880
	 *	DARK GRAY : 8800
	 *	LIGHT GRAY: 8000
	 *	WHITE     : 0000
	 *   Ƃ͏قȂ܂B
	 * * biaslƃpbgOGM-128GB21T-S-KD010̐ݒlɍ킹Ă݂ƁA
	 *   OGM-128GB21T-S-KD010̐ݒlł[ꂢɌ邱Ƃ킩܂B
	 *   biaslŔ֒ApbgŔZ֒̂ŁA
	 *   łāAǁAƓ悤ȔZxɂȂ̂Ǝv܂B
	 * * P/ECEJ[lEOGM-128GB21T-S-KD010ǂɍ킹Ă(ȂƂڂ)
	 *   Ǝv̂łAŜ߂ɁAP/ECEJ[lɍ킹邱Ƃɂ܂B
	 */
	p = buf;
	/* User Application Setup by Internal Instructions */
	/* [Display Duty Select] */
	*p++ = 0x48; *p++ = 128;
	/* [ADC Select] */
	*p++ = 0xa0 + 0;
	/* [SHL Select] */
	*p++ = 0xc0 + 8;
	/* [COM0 Register Select] */
	*p++ = 0x44; *p++ = 0;
	/* User LCD Power Setup by Internal Instructions */
	/* [Oscillator ON] */
	*p++ = 0xab;
	/* [DC-DC Step-up Register Select] */
	*p++ = 0x64 + 2;
	/* [Regulator Resistor Select] */
	*p++ = 0x20 + 6;
	/* [Electronic Volume Register Select] */
	*p++ = 0x81; *p++ = pceLCDSetBright(INVALIDVAL);
	/* [LCD Bias Register Select] */
	*p++ = 0x50 + 6;
	/* [Gray-scale Select] */
	*p++ = 0x94;			/* Set FRC and PWM mode */
	*p++ = 0x88 + 0; *p++ = 0x00;	/* Set white mode and 1/2 frame */
	*p++ = 0x88 + 1; *p++ = 0x00;	/* Set white mode and 3/4 frame */
	*p++ = 0x88 + 2; *p++ = 0x08;	/* Set light gray mode and 1/2 frame */
	*p++ = 0x88 + 3; *p++ = 0x00;	/* Set light gray mode and 3/4 frame */
	*p++ = 0x88 + 4; *p++ = 0x88;	/* Set dark gray mode and 1/2 frame */
	*p++ = 0x88 + 5; *p++ = 0x00;	/* Set dark gray mode and 3/4 frame */
	*p++ = 0x88 + 6; *p++ = 0x88;	/* Set black mode and 1/2 frame */
	*p++ = 0x88 + 7; *p++ = 0x08;	/* Set black mode and 3/4 frame */
	/* (Zbgt[ɍڂĂȂ) */
	*p++ = 0x4c; *p++ = 0x1f;	/* Set N-line inversion */
	*p++ = 0x40; *p++ = 80;		/* Set initial display line register */
	/* [Power Control] */
	*p++ = 0x28 + 7;
	len = p - buf; /* R}hoCg */

	/* LCDCo̓|[goRɐ؂ւ܂B
	 * * ݂P/ECEJ[l(1.18)́AP1xn̓o͕ݒ肵Ă܂B
	 *   Zbg̏ԂłuINv̂܂܂ɂȂĂ܂B
	 * * P32,15,16o̓|[gɐ؂ւOɓo͕ݒ肵ĂȂƁA
	 *   ͓młԂăS~MĂ܂Ƃ܂B
	 * * ܂AP32,15,16o̓|[gɐ؂ւOSCLK0ɂĂȂƁA
	 *   ȂSCLK1ɂȂăS~MĂ܂Ƃ܂B
	 *   Ô߁ASID0ɂĂƂɂ܂B
	 */
	bP3_IOC3_IOC32 = 0;	/* CSB̖߂  -> IN  (̂܂) */
	bP1_IOC1_IOC15 = 1;	/* SCLK       -> OUT (K{I) */
	bP1_IOC1_IOC16 = 1;	/* SID        -> OUT (K{I) */
	bP3_IOC3_IOC33 = 1;	/* RESETB     -> OUT (̂܂) */
	bP1_P1D_P15D = 0;	/* SCLKo͒l -> 0   (K{I) */
	bP1_P1D_P16D = 0;	/* SID o͒l -> 0   (Ô) */
	bp[0x2d7] = 0x00;	/* P32,15,16  -> o̓|[g   */

	/* LCDCZbg܂B
	 * * S6B0741f[^V[g(DS_S6B0741_V21.pdf)67y[W
	 *   uReset Input TimingvQƂĂB
	 *   iۂɂ́AP/ECECPUx(24MHz)ȂA񂺂҂ȂĂvłj
	 */
	bP3_P3D_P33D = 0;	/* RESETB -> Zbg */
	usleep(1 + 1/*덷*/);	/* ȂƂ1000[ns] */
	bP3_P3D_P33D = 1;	/* RESETB ->      */
	usleep(1 + 1/*덷*/);	/* ȂƂ1000[ns] */

	/* R}h𔭍s܂B */
	bP2_P2D_P21D = 0;	/* RS  -> R}h */
	bP2_P2D_P20D = 0;	/* CSB -> I     */
	p = buf;
	while(len-- != 0) {
		cmd = *p++;
		/* rbg7`0̏őoB
		 * * ҂ԂɂẮAS6B0741f[^V[g(DS_S6B0741_V21.pdf)66y[W
		 *   uSerial Interface CharacteristicsvQƂĂB
		 *   iۂɂ́AP/ECECPUx(24MHz)ȂA񂺂҂ȂĂvłj
		 */
		for(i = 0; i < 8; i++, cmd <<= 1) {
			bP1_P1D_P15D = 0;
			bP1_P1D_P16D = cmd & 0x80 ? 1 : 0;
			usleep(1 + 1/*덷*/);	/* ȂƂ30[ns] */
			bP1_P1D_P15D = 1;
			usleep(1 + 1/*덷*/);	/* ȂƂ30[ns] */
		}
	}
	bP2_P2D_P20D = 1;	/* CSB ->  */

	/* [Power Control] Waiting for Stabilizing the LCD Power Levels ́A
	 * f[^V[gɑ҂ԂK肳ĂȂ̂ŁAÔߒ߂ɑ҂܂B
	 * iۂɂ́AP/ECECPUx(24MHz)ȂA񂺂҂ȂĂvłj
	 */
	usleep(1000);		/* 1~b҂ĂΏ[ȁH */

	/* LCDCVAC^[tFCXoRɖ߂܂B
	 * o͕͊֌WȂ̂ŁAɖ߂Kv͂܂B
	 */
	bp[0x2d7] = 0x0e;	/* P32,15,16 -> VAI/F */

	/* RESETB[qɂ郊ZbǵADisplay ON/OFF:OFF ɂȂĂ܂B
	 * ̂ƕKvɉāApceLCDDispStart()ĂяoĂB
	 * iȂ݂ResetR}h̏ꍇ́ADisplay ON/OFFԂێ܂j
	 */
}

